﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.DragDrop;
using Telerik.Windows.DragDrop.Behaviors;

namespace WpfApplication5
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();

			IList wishlistSource = new ObservableCollection<ProductViewModel>();
			foreach (ProductViewModel product in ProductViewModel.Generate(6))
			{
				wishlistSource.Add(product);
			}

			IList wishlistSource1 = new ObservableCollection<ProductViewModel>();
			foreach (ProductViewModel product in ProductViewModel.Generate(6))
			{
				wishlistSource1.Add(product);
			}

			wishlistView.ItemsSource = wishlistSource;
			wishlistView1.ItemsSource = wishlistSource1;

			wishlistView1.Drop += OnDrop_WPF;
			//DragDropManager.AddDropHandler(wishlistView1, OnDrop_Telerik);

		}

		void OnDrop_WPF(object sender, System.Windows.DragEventArgs e)
		{
			//WORKAROUND
			//var weakRefData = DataObjectHelper.GetData(e.Data, DataFormats.Serializable, false);
			//var draggedData = (weakRefData as WeakReference).Target as IDataObject;

			//var draggedItem = DataObjectHelper.GetData(draggedData, typeof(ProductViewModel), false);

			var draggedItem = DataObjectHelper.GetData(e.Data, typeof(ProductViewModel), false);

			if (e.Effects != DragDropEffects.None && draggedItem != null)
			{
				var collection = (sender as RadTileList).ItemsSource as IList;
				collection.Add(draggedItem);
			}
		}

		private void OnDrop_Telerik(object sender, Telerik.Windows.DragDrop.DragEventArgs e)
		{
			var draggedItem = DataObjectHelper.GetData(e.Data, typeof(ProductViewModel), false);

			if (e.Effects != DragDropEffects.None && draggedItem != null)
			{
				var collection = (sender as RadTileList).ItemsSource as IList;
				collection.Add(draggedItem);
			}
		}
	}
	public class ProductViewModel
	{
		// Data generation.
		private static Random generator = new Random(1676545846);
		private static string[] adjectives = "Fabulous,Amazing,New,Classic,Modern,Durable,Outstanding,Excellent,Premium".Split(',');
		private static string[] owner = "Alaska,Jonhn,Ray,Ruby,Stone,Lilly,Scott,Barney,Dorian,Neo,Sarah".Split(',');
		private static string[] objects = "Pen,Manual,Bicycle,Umbrella,Mouse,Vase,Keyboard".Split(',');
		private static decimal[] prices = { 12.99M, 13.15M, 24.99M, 33.99M, 9.99M, 15.99M, 16.99M, 12.50M };

		public static List<ProductViewModel> Generate(int count)
		{
			List<ProductViewModel> products = new List<ProductViewModel>();
			for (int i = 0; i < count; i++)
			{
				string product = objects[generator.Next(objects.Length)];
				ProductViewModel result = new ProductViewModel();
				result.Name = String.Format("{0}'s {1} {2}",
						owner[generator.Next(owner.Length)],
						adjectives[generator.Next(adjectives.Length)],
						product);
				result.UnitPrice = prices[generator.Next(prices.Length)];
				result.Description = String.Format("Exquisite handcrafted {0}.", product.ToLower());
				products.Add(result);
			}
			return products;
		}

		public string Name { get; set; }
		public string Description { get; set; }
		public decimal UnitPrice { get; set; }
	}
}
